﻿Option Strict On

Imports Microsoft.Kinect
Imports Coding4Fun.Kinect.Wpf
Imports System.Windows.Media.Imaging

Imports Microsoft.Speech.Recognition '音声認識をするためのクラスが含まれる。
Imports Microsoft.Speech.AudioFormat '音声認識のオーディオ形式を表わすクラスが含まれる。

Imports System.IO


Public Class FancyDressInfo
    Property name As String
    Property _width As Double
    Property _height As Double
End Class
Class MainWindow
    Dim kinect As KinectSensor
    Dim engine As SpeechRecognitionEngine
    Dim words As String
    Dim bits As Byte()

 
    Dim xmldoc As XElement
 
    Dim firstSkeleton As Skeleton

    Dim _closing As Boolean = False
    Dim no As Integer = 0
    Dim no2 As Integer = 0

    Private Sub MainWindow_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        If KinectSensor.KinectSensors.Count > 0 Then
            kinect = KinectSensor.KinectSensors(0)
            kinect.Start()
        End If

        Dim sentence As Choices = New Choices
        With sentence
            .Add("マスク")
            .Add("マスクダウン")
            .Add("マスクアップ")
            .Add("部品")
            .Add("部品ダウン")
            .Add("部品アップ")
            .Add("おわり")
        End With


        Dim builder As GrammarBuilder = New GrammarBuilder
        builder.Append(sentence)
        Dim myGrammer As Grammar = New Grammar(builder)
        engine = New SpeechRecognitionEngine()
        engine.LoadGrammar(myGrammer)


        AddHandler engine.SpeechRecognized, Sub(speechSender As Object, speechArgs As SpeechRecognizedEventArgs)
                                                Dim confidence As Single = speechArgs.Result.Confidence
                                                If confidence > 0.5 Then
                                                    words = speechArgs.Result.Text
                                                    Select Case words
                                                        Case "マスク"
                                                            If ListBox1.Items.Count > 0 Then
                                                                Exit Sub
                                                            Else
                                                                xmldoc = XElement.Load("face.xml")
                                                                Dim myFancyDressInfo As New List(Of FancyDressInfo)
                                                                For Each result In From c In xmldoc.Descendants("name") Select c
                                                                    With myFancyDressInfo
                                                                        .Add(New FancyDressInfo With {.name = "Image/" & result.Value, ._height = CInt(CDbl(result.Attribute("height").Value) / 1.8), ._width = CInt(CDbl(result.Attribute("width").Value) / 1.8)})
                                                                    End With
                                                                Next
                                                                ListBox1.ItemsSource = myFancyDressInfo
                                                                ListBox1.SelectedIndex = no
                                                            End If

                                                        Case "部品"
                                                            If ListBox2.Items.Count > 0 Then
                                                                Exit Sub
                                                            Else
                                                                xmldoc = XElement.Load("goods.xml")
                                                                Dim myFancyDressInfo As New List(Of FancyDressInfo)
                                                                For Each result In From c In xmldoc.Descendants("name") Select c
                                                                    With myFancyDressInfo
                                                                        .Add(New FancyDressInfo With {.name = "Image/" & result.Value, ._height = CDbl(result.Attribute("height").Value), ._width = CDbl(result.Attribute("width").Value)})
                                                                    End With
                                                                Next
                                                                ListBox2.ItemsSource = myFancyDressInfo
                                                                ListBox2.SelectedIndex = no2
                                                            End If

                                                        Case "マスクダウン"
                                                            If no >= ListBox1.Items.Count - 1 Then no = ListBox1.Items.Count - 1
                                                            no = no + 1
                                                            ListBox1.SelectedIndex = no
                                                        Case "マスクアップ"
                                                            If no <= 0 Then no = 0
                                                            no = no - 1
                                                            ListBox1.SelectedIndex = no
                                                        Case "部品ダウン"
                                                            If no2 >= ListBox2.Items.Count - 1 Then no2 = ListBox2.Items.Count - 1
                                                            no2 = no2 + 1
                                                            ListBox2.SelectedIndex = no2
                                                        Case "部品アップ"
                                                            If no2 <= 0 Then no2 = 0
                                                            no2 = no2 - 1
                                                            ListBox2.SelectedIndex = no2
                                                        Case "おわり"
                                                            If kinect.IsRunning = True Then
                                                                kinect.Stop()
                                                                kinect.AudioSource.Stop()
                                                                engine.RecognizeAsyncStop()
                                                                kinect.Dispose()
                                                            End If
                                                            Environment.Exit(0)
                                                        Case Else
                                                            Exit Select
                                                    End Select
                                                End If
                                            End Sub

        Dim audio As KinectAudioSource = kinect.AudioSource

        Using s As Stream = audio.Start()
            engine.SetInputToDefaultAudioDevice()
            engine.RecognizeAsync(RecognizeMode.Multiple)
        End Using

        Try
            If KinectSensor.KinectSensors.Count = 0 Then
                MessageBox.Show("Kinectを接続してください")
                Exit Sub
            Else
                kinect.ColorStream.Enable()
                kinect.DepthStream.Enable()
                kinect.SkeletonStream.Enable()
                AddHandler kinect.AllFramesReady, AddressOf kinect_AllFramesReady
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Close()
        End Try
    End Sub


    Private Sub kinect_AllFramesReady(sender As Object, e As AllFramesReadyEventArgs)
        Try
            kinect = TryCast(sender, KinectSensor)
            If kinect Is Nothing Then
                Return
            End If

            Using colorFrame As ColorImageFrame = e.OpenColorImageFrame()
                personImage.Source = colorFrame.ToBitmapSource
            End Using

        Catch ex As Exception
            MessageBox.Show(ex.Message)
            Exit Sub
        End Try

        Try
            If _closing = True Then
                Return
            End If

            Using skeletonFrameData As SkeletonFrame = e.OpenSkeletonFrame()
                Dim allSkeletons As Skeleton() = New Skeleton(skeletonFrameData.SkeletonArrayLength - 1) {}
                skeletonFrameData.CopySkeletonDataTo(allSkeletons)
                firstSkeleton = (From s In allSkeletons Where s.TrackingState = SkeletonTrackingState.Tracked Select s).FirstOrDefault()
            End Using

            If firstSkeleton Is Nothing Then
                Return
            End If

            ScalePosition(faceImage, firstSkeleton.Joints(JointType.Head))
            ScalePosition(rightHandImage, firstSkeleton.Joints(JointType.HandRight))

            GetCameraPoint(firstSkeleton, e)
        Catch
            Exit Sub
        End Try
    End Sub


    Private Sub GetCameraPoint(ByVal first As Skeleton, ByVal e As AllFramesReadyEventArgs)

        'Using depth As DepthImageFrame = e.OpenDepthImageFrame()
        '    If depth Is Nothing = True Then
        '        Return
        '    End If
        'KINECT SDK 1.6対応
        Dim headDepthPoint As DepthImagePoint = kinect.CoordinateMapper.MapSkeletonPointToDepthPoint(first.Joints(JointType.Head).Position, DepthImageFormat.Resolution640x480Fps30)
        Dim rightDepthPoint As DepthImagePoint = kinect.CoordinateMapper.MapSkeletonPointToDepthPoint(first.Joints(JointType.HandRight).Position, DepthImageFormat.Resolution640x480Fps30)

        Dim headColorPoint As ColorImagePoint = kinect.CoordinateMapper.MapDepthPointToColorPoint(DepthImageFormat.Resolution640x480Fps30, headDepthPoint, ColorImageFormat.InfraredResolution640x480Fps30)
        Dim rightColorPoint As ColorImagePoint = kinect.CoordinateMapper.MapDepthPointToColorPoint(DepthImageFormat.Resolution640x480Fps30, rightDepthPoint, ColorImageFormat.InfraredResolution640x480Fps30)

        CameraPosition(faceImage, headColorPoint)
        CameraPosition(rightHandImage, rightColorPoint)
        'End Using
    End Sub

    Private Sub CameraPosition(ByVal element As FrameworkElement, ByVal point As ColorImagePoint)
        
        Canvas.SetLeft(element, point.X - (CLng(element.Width) / 2))
        Canvas.SetTop(element, point.Y - (CLng(element.Height) / 2))

    End Sub

    Private Sub ScalePosition(ByVal element As FrameworkElement, ByVal joint As Joint)

        Dim scaledJoint As Joint = joint.ScaleTo(1920, 1080)

        Canvas.SetLeft(element, scaledJoint.Position.X)
        Canvas.SetTop(element, scaledJoint.Position.Y)

    End Sub


    Private Sub ListBox1_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles ListBox1.SelectionChanged

        Dim myWidth = CInt(DirectCast(ListBox1.SelectedItem, FancyDressInfo)._width)
        Dim myHeight = CInt(DirectCast(ListBox1.SelectedItem, FancyDressInfo)._height)
        Dim mySource = New BitmapImage(New Uri(DirectCast(ListBox1.SelectedItem, FancyDressInfo).name, UriKind.Relative))
        faceImage.Width = myWidth / 2
        faceImage.Height = myHeight / 2
        faceImage.Source = mySource

    End Sub

    Private Sub ListBox2_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles ListBox2.SelectionChanged
        Dim myWidth = CInt(DirectCast(ListBox2.SelectedItem, FancyDressInfo)._width)
        Dim myHeight = CInt(DirectCast(ListBox2.SelectedItem, FancyDressInfo)._height)
        Dim mySource = New BitmapImage(New Uri(DirectCast(ListBox2.SelectedItem, FancyDressInfo).name, UriKind.Relative))
        rightHandImage.Width = myWidth
        rightHandImage.Height = myHeight
        rightHandImage.Source = mySource

    End Sub


    Private Sub MainWindow_Closing(sender As Object, e As System.ComponentModel.CancelEventArgs) Handles Me.Closing
        If kinect Is Nothing = False Then
            If kinect.IsRunning = True Then
                RemoveHandler kinect.AllFramesReady, AddressOf kinect_AllFramesReady
                kinect.Stop()
                engine.RecognizeAsyncStop()
                kinect.Dispose()
            End If
        End If

    End Sub

   
End Class
